Upstream information

CVE-2021-43860 at MITRE

Description

Flatpak is a Linux application sandboxing and distribution framework. Prior to versions 1.12.3 and 1.10.6, Flatpak doesn't properly validate that the permissions displayed to the user for an app at install time match the actual permissions granted to the app at runtime, in the case that there's a null byte in the metadata file of an app. Therefore apps can grant themselves permissions without the consent of the user. Flatpak shows permissions to the user during install by reading them from the "xa.metadata" key in the commit metadata. This cannot contain a null terminator, because it is an untrusted GVariant. Flatpak compares these permissions to the *actual* metadata, from the "metadata" file to ensure it wasn't lied to. However, the actual metadata contents are loaded in several places where they are read as simple C-style strings. That means that, if the metadata file includes a null terminator, only the content of the file from *before* the terminator gets compared to xa.metadata. Thus, any permissions that appear in the metadata file after a null terminator are applied at runtime but not shown to the user. So maliciously crafted apps can give themselves hidden permissions. Users who have Flatpaks installed from untrusted sources are at risk in case the Flatpak has a maliciously crafted metadata file, either initially or in an update. This issue is patched in versions 1.12.3 and 1.10.6. As a workaround, users can manually check the permissions of installed apps by checking the metadata file or the xa.metadata key on the commit metadata.

SUSE information

Overall state of this security issue: Resolved

This issue is currently rated as having important severity.

CVSS v2 Scores
  National Vulnerability Database
Base Score 6.8
Vector AV:N/AC:M/Au:N/C:P/I:P/A:P
Access Vector Network
Access Complexity Medium
Authentication None
Confidentiality Impact Partial
Integrity Impact Partial
Availability Impact Partial
CVSS v3 Scores
  National Vulnerability Database SUSE
Base Score 8.6 8.2
Vector CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N
Attack Vector Local Local
Attack Complexity Low Low
Privileges Required None None
User Interaction Required Required
Scope Changed Changed
Confidentiality Impact High High
Integrity Impact High High
Availability Impact High None
CVSSv3 Version 3.1 3.1
SUSE Bugzilla entry: 1194610 [RESOLVED / FIXED]

SUSE Security Advisories:

List of released packages

Product(s) Fixed package version(s) References
SUSE CaaS Platform 4.0
  • flatpak >= 1.2.3-150100.4.8.1
  • flatpak-devel >= 1.2.3-150100.4.8.1
  • flatpak-zsh-completion >= 1.2.3-150100.4.8.1
  • libflatpak0 >= 1.2.3-150100.4.8.1
  • typelib-1_0-Flatpak-1_0 >= 1.2.3-150100.4.8.1
Patchnames:
SUSE-SUSE-CAASP-4.0-2022-3284
SUSE Enterprise Storage 6
  • flatpak >= 1.2.3-150100.4.8.1
  • flatpak-devel >= 1.2.3-150100.4.8.1
  • flatpak-zsh-completion >= 1.2.3-150100.4.8.1
  • libflatpak0 >= 1.2.3-150100.4.8.1
  • typelib-1_0-Flatpak-1_0 >= 1.2.3-150100.4.8.1
Patchnames:
SUSE-Storage-6-2022-3284
SUSE Enterprise Storage 7.1
SUSE Linux Enterprise Desktop 15 SP3
SUSE Linux Enterprise High Performance Computing 15 SP3
SUSE Linux Enterprise Module for Desktop Applications 15 SP3
SUSE Linux Enterprise Server 15 SP3
SUSE Linux Enterprise Server for SAP Applications 15 SP3
SUSE Manager Proxy 4.2
SUSE Manager Retail Branch Server 4.2
SUSE Manager Server 4.2
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Module-Desktop-Applications-15-SP3-2022-712
SUSE Enterprise Storage 7
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-Storage-7-2022-712
SUSE Linux Enterprise Desktop 15 SP4
SUSE Linux Enterprise High Performance Computing 15 SP4
SUSE Linux Enterprise Module for Desktop Applications 15 SP4
SUSE Linux Enterprise Server 15 SP4
SUSE Linux Enterprise Server for SAP Applications 15 SP4
SUSE Manager Proxy 4.3
SUSE Manager Retail Branch Server 4.3
SUSE Manager Server 4.3
  • flatpak >= 1.12.5-150400.1.11
  • flatpak-devel >= 1.12.5-150400.1.11
  • flatpak-zsh-completion >= 1.12.5-150400.1.11
  • libflatpak0 >= 1.12.5-150400.1.11
  • system-user-flatpak >= 1.12.5-150400.1.11
  • typelib-1_0-Flatpak-1_0 >= 1.12.5-150400.1.11
Patchnames:
SUSE Linux Enterprise Module for Desktop Applications 15 SP4 GA flatpak-1.12.5-150400.1.11
SUSE Linux Enterprise High Performance Computing 15 SP1-ESPOS
  • flatpak >= 1.2.3-150100.4.8.1
  • flatpak-devel >= 1.2.3-150100.4.8.1
  • flatpak-zsh-completion >= 1.2.3-150100.4.8.1
  • libflatpak0 >= 1.2.3-150100.4.8.1
  • typelib-1_0-Flatpak-1_0 >= 1.2.3-150100.4.8.1
Patchnames:
SUSE-SLE-Product-HPC-15-SP1-ESPOS-2022-3284
SUSE Linux Enterprise High Performance Computing 15 SP1-LTSS
  • flatpak >= 1.2.3-150100.4.8.1
  • flatpak-devel >= 1.2.3-150100.4.8.1
  • flatpak-zsh-completion >= 1.2.3-150100.4.8.1
  • libflatpak0 >= 1.2.3-150100.4.8.1
  • typelib-1_0-Flatpak-1_0 >= 1.2.3-150100.4.8.1
Patchnames:
SUSE-SLE-Product-HPC-15-SP1-LTSS-2022-3284
SUSE Linux Enterprise High Performance Computing 15 SP2-ESPOS
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Product-HPC-15-SP2-ESPOS-2022-712
SUSE Linux Enterprise High Performance Computing 15 SP2-LTSS
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Product-HPC-15-SP2-LTSS-2022-712
SUSE Linux Enterprise Real Time 15 SP2
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Product-RT-15-SP2-2022-712
SUSE Linux Enterprise Server 15 SP1-BCL
  • flatpak >= 1.2.3-150100.4.8.1
  • flatpak-devel >= 1.2.3-150100.4.8.1
  • flatpak-zsh-completion >= 1.2.3-150100.4.8.1
  • libflatpak0 >= 1.2.3-150100.4.8.1
  • typelib-1_0-Flatpak-1_0 >= 1.2.3-150100.4.8.1
Patchnames:
SUSE-SLE-Product-SLES-15-SP1-BCL-2022-3284
SUSE Linux Enterprise Server 15 SP1-LTSS
  • flatpak >= 1.2.3-150100.4.8.1
  • flatpak-devel >= 1.2.3-150100.4.8.1
  • flatpak-zsh-completion >= 1.2.3-150100.4.8.1
  • libflatpak0 >= 1.2.3-150100.4.8.1
  • typelib-1_0-Flatpak-1_0 >= 1.2.3-150100.4.8.1
Patchnames:
SUSE-SLE-Product-SLES-15-SP1-LTSS-2022-3284
SUSE Linux Enterprise Server 15 SP2-BCL
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Product-SLES-15-SP2-BCL-2022-712
SUSE Linux Enterprise Server 15 SP2-LTSS
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Product-SLES-15-SP2-LTSS-2022-712
SUSE Linux Enterprise Server for SAP Applications 15 SP1
  • flatpak >= 1.2.3-150100.4.8.1
  • flatpak-devel >= 1.2.3-150100.4.8.1
  • flatpak-zsh-completion >= 1.2.3-150100.4.8.1
  • libflatpak0 >= 1.2.3-150100.4.8.1
  • typelib-1_0-Flatpak-1_0 >= 1.2.3-150100.4.8.1
Patchnames:
SUSE-SLE-Product-SLES_SAP-15-SP1-2022-3284
SUSE Linux Enterprise Server for SAP Applications 15 SP2
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Product-SLES_SAP-15-SP2-2022-712
SUSE Manager Proxy 4.1
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Product-SUSE-Manager-Proxy-4.1-2022-712
SUSE Manager Retail Branch Server 4.1
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Product-SUSE-Manager-Retail-Branch-Server-4.1-2022-712
SUSE Manager Server 4.1
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
SUSE-SLE-Product-SUSE-Manager-Server-4.1-2022-712
openSUSE Leap 15.3
  • flatpak >= 1.10.7-4.12.1
  • flatpak-devel >= 1.10.7-4.12.1
  • flatpak-zsh-completion >= 1.10.7-4.12.1
  • libflatpak0 >= 1.10.7-4.12.1
  • system-user-flatpak >= 1.10.7-4.12.1
  • typelib-1_0-Flatpak-1_0 >= 1.10.7-4.12.1
Patchnames:
openSUSE-SLE-15.3-2022-712
openSUSE Leap 15.4
  • flatpak >= 1.12.5-150400.1.11
  • libflatpak0 >= 1.12.5-150400.1.11
  • system-user-flatpak >= 1.12.5-150400.1.11
Patchnames:
openSUSE Leap 15.4 GA flatpak-1.12.5-150400.1.11
openSUSE Tumbleweed
  • flatpak >= 1.12.3-1.1
  • flatpak-devel >= 1.12.3-1.1
  • flatpak-zsh-completion >= 1.12.3-1.1
  • libflatpak0 >= 1.12.3-1.1
  • system-user-flatpak >= 1.12.3-1.1
  • typelib-1_0-Flatpak-1_0 >= 1.12.3-1.1
Patchnames:
openSUSE Tumbleweed GA flatpak-1.12.3-1.1


Status of this issue by product and package

Please note that this evaluation state might be work in progress, incomplete or outdated. Also information for service packs in the LTSS phase is only included for issues meeting the LTSS criteria. If in doubt, feel free to contact us for clarification.

Product(s) Source package State
SUSE CaaS Platform 4.0 flatpak Released
SUSE Enterprise Storage 6 flatpak Released
SUSE Enterprise Storage 7 flatpak Released
SUSE Enterprise Storage 7.1 flatpak Released
SUSE Linux Enterprise Desktop 15 SP2 flatpak Released
SUSE Linux Enterprise Desktop 15 SP3 flatpak Released
SUSE Linux Enterprise Desktop 15 SP4 flatpak Already fixed
SUSE Linux Enterprise High Performance Computing 15 SP1-ESPOS flatpak Released
SUSE Linux Enterprise High Performance Computing 15 SP1-LTSS flatpak Released
SUSE Linux Enterprise High Performance Computing 15 SP2 flatpak Released
SUSE Linux Enterprise High Performance Computing 15 SP2-ESPOS flatpak Released
SUSE Linux Enterprise High Performance Computing 15 SP2-LTSS flatpak Released
SUSE Linux Enterprise High Performance Computing 15 SP3 flatpak Released
SUSE Linux Enterprise High Performance Computing 15 SP4 flatpak Already fixed
SUSE Linux Enterprise High Performance Computing 15-LTSS flatpak Won't fix
SUSE Linux Enterprise Module for Desktop Applications 15 SP2 flatpak Released
SUSE Linux Enterprise Module for Desktop Applications 15 SP3 flatpak Released
SUSE Linux Enterprise Module for Desktop Applications 15 SP4 flatpak Already fixed
SUSE Linux Enterprise Real Time 15 SP2 flatpak Released
SUSE Linux Enterprise Server 15 SP1-LTSS flatpak Released
SUSE Linux Enterprise Server 15 SP2 flatpak Released
SUSE Linux Enterprise Server 15 SP2-LTSS flatpak Released
SUSE Linux Enterprise Server 15 SP3 flatpak Released
SUSE Linux Enterprise Server 15 SP4 flatpak Already fixed
SUSE Linux Enterprise Server 15-ESPOS flatpak Won't fix
SUSE Linux Enterprise Server 15-LTSS flatpak Won't fix
SUSE Linux Enterprise Server Business Critical Linux 15 SP1 flatpak Released
SUSE Linux Enterprise Server Business Critical Linux 15 SP2 flatpak Released
SUSE Linux Enterprise Server for SAP Applications 15 flatpak Won't fix
SUSE Linux Enterprise Server for SAP Applications 15 SP1 flatpak Released
SUSE Linux Enterprise Server for SAP Applications 15 SP2 flatpak Released
SUSE Linux Enterprise Server for SAP Applications 15 SP3 flatpak Released
SUSE Linux Enterprise Server for SAP Applications 15 SP4 flatpak Already fixed
SUSE Manager Proxy 4.1 flatpak Released
SUSE Manager Proxy 4.2 flatpak Released
SUSE Manager Proxy 4.3 flatpak Already fixed
SUSE Manager Retail Branch Server 4.1 flatpak Released
SUSE Manager Retail Branch Server 4.2 flatpak Released
SUSE Manager Retail Branch Server 4.3 flatpak Already fixed
SUSE Manager Server 4.1 flatpak Released
SUSE Manager Server 4.2 flatpak Released
SUSE Manager Server 4.3 flatpak Already fixed


SUSE Timeline for this CVE

CVE page created: Wed Jan 12 21:45:04 2022
CVE page last modified: Fri Nov 25 17:51:25 2022